#include <elib/command.h>
#include <skip/skip.h>
#include <anemone.h>
#include <path.h>
#include <elib/table.h>
#include <unistd.h>
#include <fcntl.h>
#include <elib/string.h>
#include <elib/memory.h>
#include <stdarg.h>

static char xfont_hack[]=
"-adobe-new century schoolbook-bold-r-normal--14-140-75-75-p-87-iso8859-1";
char *x_display_font=xfont_hack;
static char startup_hack[]=DEFAULT_STARTUP;
static char *startup=startup_hack;
static int startup_fd;
static int xsize=500;
static int ysize=400;
static int xoff=0;
static int yoff=0;
static float xscale=1.0;
static float yscale=1.0;
static int ndt=0;
void set_default_width();
extern void skip_load_file();


static int each_hint_entry(node e,int fd)
{
  char output[128];

  sprintf(output,"node_hint %s %f %f %s %f %f\n",e->name,e->x,e->y,
	  shape_name(e->sh),e->width,e->height); 
  write(fd,output,string_length(output));
}


void dump_startup(space s)
{
  if ((startup_fd=open(startup,O_RDWR|O_TRUNC|O_CREAT,0664))>0){
    /*    lseek(startup_fd,SEEK_SET,0);*/
    iterate_table_entries(s->nodes,each_hint_entry,startup_fd);
    close(startup_fd);
  }
}


static void set_string (char **s,char *value){*s=duplicate_string(value);}
static void set_bool (int *s,char *value){*s=1;}
static void set_float (float *a,float *b){*a=*b;}

extern space create_postscript_display(float, float,float ,int);

void start_postscript(space *s)
{
  *s=create_postscript_display( xoff, yoff, xscale,1);
}

void start_connection(char *a,char *b)
{
  assemble_stack(2,create_skip_layer(skip_global_environment),
		 tcp_create_client(make_sockaddr_in(a,b)));
}

void my_snap(space *s)
{
  snap(*s);
}
extern void set_node_default();
extern void set_edge_default();

void my_group_node(space s,char *c,int n,...)
{
    int i;
    va_list a;
    list j=0;
    char *z;
    va_start (a,n);
    for (i=0;i<(n-2);i++){
	z=va_arg(a,char *);
	j=insert(create_node(s,z),j);
    }
    group_nodes(s,c,j);
    va_end(a);
}

void set_y_scale(space s,float *y)
{
  s->yscale=*y;
}

void set_x_scale(space s,float *x)
{
  s->xscale=*x;
}
char *getenv();
void x_space (space *q,int nargs,char *display)
{
  *q=(space)attach_x_display((nargs>1)?display:getenv("DISPLAY"),xsize,ysize,
			     xoff,yoff);
}


void node_position_file(char *name)
{
  startup=duplicate_string(name);
  skip_load_file(skip_global_environment,startup);
}

static void async_ndt_load(space s,char *name)
{
  int fd;
  if ((fd=open(name,O_RDONLY)) < 0){
    printf ("couldn't open %s for loading\n",name);
    return;
  }
  assemble_stack(2,create_ndt_layer(s),
		 create_filedesc(fd,-1,512,0));
}

static void async_load(environment e,char *name)
{
  int fd;
  if ((fd=open(name,O_RDONLY)) < 0){
    printf ("couldn't open %s for loading\n",name);
    return;
  }
  assemble_stack(2,create_skip_layer(e),
		 create_filedesc(fd,-1,512,0));
}


void skip_autosize()
{
}

void skip_sleep()
{
}

void create_node_hint(space s,char *name,
		      float *x,float *y,char *shape,
		      char *width,char *height)
{
  node h=(node)create_node(s,name);
  move_node(s,h,*x,*y);
  node_property(s,name,"width",width);
  node_property(s,name,"height",height);
  node_property(s,name,"shape",shape);
}



void set_int(int *n,int k){  *n=k; }
void set_int_pair(int *n,int a,int b){  n[0]=a; n[1]=b;}

main(int argc,char **argv)
{
  char temp_name[256];
  command_space sp=create_command_space(0);
  int x,y;
  space s=0;

  init_unix_timer();
  initialize_skip();
  initialize_shapes();

  command_type (sp,"i","integer",
		command_parse_decimal,
		command_print_decimal,0);
  command_type (sp,"s","string",command_parse_string,
		command_print_string,0);
  command_type (sp,"n","nargs",
		command_parse_number_of_arguments,0,0,0);
  command_type (sp,"f","float",command_parse_float,
		command_print_float,deallocate_memory);
  command_type (sp,"x","hex",command_parse_hex,
		command_print_hex,deallocate_memory);
  command_type (sp,"@","context",command_parse_context,0,0,0);
  command_function(sp,set_string,"startup","","@s",&startup);
  command_function(sp,start_postscript,"ps","","@",&s);
  command_function(sp,set_string,"scale","","@i",&s);
  command_function(sp,x_space,"x","","@ns",&s);
  command_function(sp,skip_load_file,"sync_load","","@s",
		   skip_global_environment);
  command_function(sp,async_load,"load","","@s",skip_global_environment);
  command_function(sp,set_float,"xoff","","@f",&xoff);
  command_function(sp,set_float,"yoff","","@f",&yoff);
  command_function(sp,set_float,"xscale","","@f",&xscale);
  command_function(sp,set_float,"yscale","","@f",&yscale);
  command_function(sp,set_bool,"ndt","","@",&ndt);
  command_function(sp,set_string,"font","","@s",&x_display_font);
  command_function(sp,start_connection,"connect","","ss");
  malloc(5);
  command_line_dispatch(sp,argc,argv);
  malloc(5);
  if (!s) x_space(&s,1,0);
  skip_function(node_position_file,"node_position_file","","s",s);
  skip_function(create_node,"create_node","","@s",s);
  skip_function(create_edge,"create_edge","","@sss",s);
  skip_function(create_node,"node","","@s",s);
  skip_function(create_edge,"edge","","@sss",s);
  skip_function(create_background_line,"background_line","","@sf$",s);
  skip_function(edge_property,"edge_property","","@sss",s);
  skip_function(node_property,"node_property","","@sss",s);
  skip_function(set_edge_default,"edge_default","","@ss",s);
  skip_function(set_node_default,"node_default","","@ss",s);
  skip_function(skip_autosize,"autosize","","@",s);
  skip_function(skip_sleep,"sleep","","@i",s);
  skip_function(set_x_scale,"xscale","","@f",s);
  skip_function(set_y_scale,"yscale","","@f",s);
  skip_function(my_group_node,"group","","@sns*",s);
  skip_function(my_snap,"snap","","@",&s);
  skip_function(create_node_hint,"node_hint","","@sffsss",s);
  skip_function(async_load,"load","","@s",skip_global_environment);
  skip_function(skip_load_file,"sync_load","","@s",skip_global_environment);
  skip_function(async_ndt_load,"load_ndt","","@s",s);
  skip_load_file(skip_global_environment,startup);
  if (ndt){
    assemble_stack(2,create_ndt_layer(s),
		   create_filedesc(0,-1,512,0));
  } else {
    assemble_stack(2,create_skip_layer(skip_global_environment),
		   create_filedesc(0,-1,512,0));
  }
  timer_loop(1,0);
}

