#include <anemone.h>

cell create_cell(cell parent)
{
  cell q=(cell)allocate_memory(sizeof(struct cell));
  q->children[0]=q->children[1]=q->children[2]=q->children[3]=0;
  q->parent=0;
  q->instruments=0;
  return(q);
}

void move_instrument(instrument i,float x0,float y0,float x1,float y1)
{
  i->x0=x0;
  i->y0=y0;
  i->x1=x1;
  i->y1=y1;
}

/* should be float*/
instrument insert_instrument(cell q,
			     int (*probe)(void *,float,float),
			     void (*draw)(),
			     void (*move)(space,void *,float,float),
			     void *local,
			     float x0,float y0,float x1,float y1,
			     int depth)
{
  instrument i=(instrument)allocate_memory(sizeof(struct instrument));
  i->probe=probe;
  i->draw=draw;
  i->local=local;
  i->move=move;

  /* these should be sorted by depth*/
  i->prev=&q->instruments;
  i->next=q->instruments;
  if (q->instruments) q->instruments->prev=&(i->next);
  q->instruments=i;
  i->location=q;

  i->depth=depth; 
  i->x0=x0;
  i->x1=x1;
  i->y0=y0;
  i->y1=y1;
  return(i);
  /* if disjoint children then split*/
}

instrument which_instrument (cell q,float x0,float y0)
{
  instrument i,j=0;
  unsigned int current_depth;
  for (i=q->instruments;i;i=i->next)
    if (((i->depth < current_depth) || (!j)) &&
	i->probe &&
	(*i->probe)(i->local,x0,y0)){
      current_depth=i->depth;
      j=i;
    }
  return(j);
}

void foreach_instrument(cell q,void (*function)(), void *arg)
{
  instrument i;
  for (i=q->instruments;i;i=i->next)
    (*function)(i,arg);
}

void foreach_instrument_in(cell q,
			   float x0,float y0,float x1,float y1,
			   unsigned int depth,
			   void (*function)(), void *arg)
{
  instrument i;
  for (i=q->instruments;i;i=i->next)
    if ((i->x0 < x1) &&
	(i->x1 > x0) &&
	(i->y0 < y1) &&
	(i->y1 > y0))
      (*function)(i,arg);

  /*      if ((MAX(i->x0,x0) > MIN (i->x1,x1)) &&
	(MAX(i->y0,y0) < MIN (i->y1,y1)) &&
	(i->depth < depth)) */
}

void remove_instrument(instrument i)
{
  int j;
  instrument k;
  *(i->prev)=i->next;
  if (i->next) i->next->prev=i->prev;
  deallocate_memory(i);
}
