#ifndef ELIB_COMMAND
#define ELIB_COMMAND 1
#include <elib/table.h>

typedef struct command_type_handler {
  unsigned char desc;
  char *name;
  void *(*conversion_function)();
  char *(*print_function)();
  void (*deallocate_memory)();
  void *context;
} *command_type_handler;

typedef struct command {
  int number_of_arguments;
  char *name;
  char *return_type;
  char *arguments;
  void *(*f)();
  void *arg;
} *command;

typedef struct command_space {
  struct command_space *parent;
  command_type_handler handlers[96];
  table types;
  table commands;
  void (*ef)();
} *command_space;

command_space create_command_space();
unsigned int command_parse_hex();
char *command_print_hex();
int command_parse_decimal();
char *command_print_decimal();
float *command_parse_float(char *);
char *command_print_float(float);
char *command_parse_string();
char *command_print_string();

char *command_dispatch();
char *command_string_dispatch();
void *command_parse_context();
void *command_parse_number_of_arguments();
char *command_print_value();
#define MAX_COMMAND_ARGUMENTS 32

#endif
