#include <elib/list.h>
#include <stdarg.h>

list insert (void *first,list rest)
{
  list new=(list)allocate_memory(sizeof(struct list));
  new->first=first;
  new->rest=rest;
  return(new);
}


list copy_list (list l)
{
  if (l) {
    return(insert(l->first,copy_list(l->rest)));
  } else return (0);
}

list create_list_recurse (args,number)
     va_list args;
     int number;
{
  void *temp=va_arg(args,void *);
  if (number == 1) return(temp);
  return (insert(temp,create_list_recurse(args,number-1)));
}

list create_list (int number,...)
{
  va_list args;
  list result;
  
  va_start(args,number);
  result=create_list_recurse(args,number);
  va_end(args);
  return(result);
}

list append_list (list *a,list b)
{
  list *i;
  for (i=a;*i;i=&(*i)->rest);
  *i=b;
  return(*a);
}

int length (list a)
{
  list i;
  int result=0;
  for(i=a;i;i=i->rest) result++;
  return(result);
}

void delete_elements_from_list(list *l, int (*compare)(), 
			       void *compare_arg, void (*destroy)())
{
  list *i,*next,temp;
  for (i=l;*i;i=next){
    next=&((*i)->rest);
    if ((*compare)((*i)->first,compare_arg)){
      if (destroy) (*destroy)((*i)->first);
      temp=*i;
      *i=(*i)->rest;
      deallocate_memory(temp);
      next=i;
    }
  }
}
       
void *nth (list l, int n)
{
  int j;
  list i;

  for (j=0,i=l;i&&j<n;j++,i=i->rest);
  if (i) return(i->first);
  return(0);
}


void destroy_list (list l, void (*destroy_elements)())
{
  list i,next;
  for (i=l;i;i=next){
    next=i->rest;
    if (destroy_elements) (*destroy_elements)(i->first);
    deallocate_memory (i);
  }
}


void foreach (list *l, int (*function)(), void *arg)
{
  list *k;
  list *next;
  list temp;

  for (k=l;*k;k=next){
    next=&((*k)->rest);
    if (!(*function)((*k)->first,arg)){
      if (temp=*k){ /* cheesy*/
	*k=(*k)->rest;
	next=k;
	deallocate_memory(temp);
      }
    }
  }
}
