#include <sys/cdefs.h>
#include <sys/types.h>
#include <machine/types.h>
#include <vm/vm.h>
#include <vm/vm_kern.h>
#include <machine/psl.h>

#define USE_LITTLE_ENDIAN 1

#define high_priority() splhigh()
#define reset_priority(x) spl0()
#define _inline_ inline

#define TPROC (curproc)

#ifdef PROCESS
#define TIME gettimeofday
#define new_page(size) ((unsigned char *)sbrk(size))
#define GETSERVICE(x) getservbyname(x,0)
#endif

#ifdef KERNEL
#define TIME(x,y) microtime(x)
#define new_page(x) ((void *)kmem_alloc(kernel_map,x))
#endif
typedef struct selinfo select_state;
#define ANSI_CPP 1

#ifdef USE_LITTLE_ENDIAN

static unsigned int byte_mask[4]={0x000000ff,0x0000ff00,0x00ff0000,0xff000000};
static unsigned int byte_shift[4]={0,8,16,24};
#define vntohl(x) \
   ((((x)>>24)&0xff)|(((x)>>8)&0x0000ff00)|(((x)<<8)&0x00ff0000)|((x)<<24))
#define vntohs(x) (((x)>>8)|((x)<<8))

#else

static unsigned int byte_mask[4]={0xff000000,0x00ff0000,0x0000ff00,0x000000ff};
static unsigned int byte_shift[4]={24,16,8,0};
#define vntohl(x) (x)
#define vntohs(x) (x)

#endif

#define vhtonl(x) vntohl(x)
#define vhtons(x) vntohs(x)

#ifndef PUT_BYTE
#define PUT_BYTE(a,i,v) (a)[(i)]=(v)
#endif

#ifndef TIME 
#define TIME(x,y) 1
#endif
