#include <elib/pqueue.h>

/* both of these functions are 1-indexed*/
int heal_pqueue(pqueue p,int where)
{
  int left=(where<<1)-1;
  int right=(where<<1);
  int min=where-1;
  struct pqueue_element temp;
  
  if (left < p->number_of_elements)
    if ((*p->ordering_function)
	(p->elements[left].index,p->elements[min].index)) min=left;
  if (right < p->number_of_elements)
    if ((*p->ordering_function)
	(p->elements[right].index,p->elements[min].index)) min=right;
  if (min != (where-1)){
    temp=p->elements[where-1];
    p->elements[where-1]=p->elements[min];
    p->elements[min]=temp;
    heal_pqueue(p,min+1);
    return(1);
  }
  return(0);
}


pqueue create_pqueue(int (*ordering_function)())
{
  pqueue new=(pqueue) allocate_memory(sizeof(struct pqueue));
  new->number_of_elements=0;
  new->size_of_pqueue=1;
  new->elements=(pqueue_element)allocate_memory(sizeof(struct pqueue_element));
  new->ordering_function=ordering_function;
  return(new);
}

/* this is also one based*/
void add_pqueue(pqueue p, int i)
{
  struct pqueue_element temp;
  int me=i-1;
  int parent=(i>>1)-1;
  if (i>1)
    if ((*p->ordering_function)
	(p->elements[me].index,p->elements[parent].index)){
      temp=p->elements[me];
      p->elements[me]=p->elements[parent];
      p->elements[parent]=temp;
      add_pqueue(p,i>>1);
    }
}

void push_pqueue(pqueue p,void *value,void *index)
{ 
  int i;
  int new_element=p->number_of_elements++;
  if (p->size_of_pqueue<p->number_of_elements){
    p->elements=
      (pqueue_element)reallocate_memory(p->elements,
					(p->number_of_elements)*
					sizeof(struct pqueue_element));
    p->size_of_pqueue=p->number_of_elements;
  }
  p->elements[new_element].index=index;
  p->elements[new_element].value=value;
  
  add_pqueue(p,new_element+1);
/*  heal_pqueue(p,1);*/
}

void *pop_pqueue(pqueue p)
{
  void *result=0;
  if (p->number_of_elements){
    result=p->elements[0].value;
    p->elements[0]=p->elements[--p->number_of_elements];
    heal_pqueue(p,1);
  }
  return(result);
}

/*  should do the index too*/
void destroy_pqueue(pqueue p,void (*destroy_indices)(),
		    void (*destroy_elements)())
{
  int i;
  if (destroy_elements || destroy_indices)
    for (i=0;i<p->number_of_elements;i++){
      if (destroy_indices)
	(*destroy_indices)(p->elements[i].value);
      if (destroy_elements)
	(*destroy_elements)(p->elements[i].value);
    }
  deallocate_memory(p->elements);
  deallocate_memory(p);
}
