#include <elib/list.h>
#include <elib/rmap.h>

static int mark_to (rmap start,int state,unsigned int to,int flag)
{
  list temp;
 
  if (to >= (int)(*start)->first){
    temp=*start;
    *start=(*start)->rest;
    deallocate_memory(temp);
    return(mark_to(start,state^1,to,flag));
  }
  if (flag^state) *start=insert(to,*start);
}

static int rmap_internal(rmap m,unsigned int from,unsigned int to,int flag,
			 int on)
{
  unsigned int f,t;
  list *temp;

  f=(int)(*m)->first;
  if (from > f) return (rmap_internal(&((*m)->rest),from,to,flag,on^1));
  if ((from<f) && (on^flag)) {
    *m=insert(from,*m);
    m=&((*m)->rest);
  }
  return (mark_to(m,on,to,flag));
}

int rmap_allocate(rmap m,unsigned int from,unsigned int to)
{
  return(rmap_internal(m,from,to,1,1));
}

unsigned int rmap_allocate_arbitrary(rmap m,int size)
{
  list i;
  unsigned int from,to;

  for (i=*m;i;i=i->rest->rest){
    from=(int)i->first;
    to=(int)i->rest->first;
    if ((to-from) >= size){
      rmap_allocate(m,from,from+size);
      return(from);
    }
  }
  return(0);
}


void rmap_deallocate(rmap m,int from,int to)
{
  rmap_internal(m,from,to,0,1);
}

rmap create_rmap(min,max)
{
  rmap z=(rmap)allocate_memory(sizeof(list *));
  *z=create_list(3,min,max,0);
  return(z);
}
