#include <anemone.h>
#include <math.h>

static void centering(node n)
{
  edge e;
  int c=0;
  float len,x=0,y=0;
  for (e=n->froms;e;e=e->from_next){
    x+=e->to->x;
    y+=e->to->y;
    c++;
  }
  for (e=n->tos;e;e=e->to_next){
    x+=e->from->x;
    y+=e->from->y;
    c++;
  }
  x=n->x-x/c;
  y=n->y-y/c;
  if ((len=sqrt(x*x+y*y)) > 2.0){
    n->fx-=x*0.1; /*2.0/len;*/
    n->fy-=y*0.1; /*2.0/len;*/
   }
}

static void equalize_lengths(node n)
{
}

static void angular_equality()
{
}

static void edge_crossing()
{
}

static void edge_spring(node n)
{
  edge e;
  float desired=100.0;
  float len,x,y;
  for (e=n->froms;e;e=e->from_next){
    x=n->x-e->to->x;
    y=n->y-e->to->y;
    if (len=sqrt(x*x+y*y))
      if (fabs(len-desired) > 2.0){
	len*=((len-desired)<0.0)?1.0:-1.0;
	n->fx+=2.0*x/len;
	n->fy+=2.0*y/len;
      }
  }
  for (e=n->tos;e;e=e->to_next){
    x=n->x-e->from->x;
    y=n->y-e->from->y;
    if (len=sqrt(x*x+y*y))
      if (fabs(len-desired) > 2.0){
	len*=((len-desired)<0.0)?1.0:-1.0;  
	n->fx+=0.1*x*((len-desired)<0.0)?1.0:-1.0; /*2.0*x/len;*/
	n->fy+=0.1*y*((len-desired)<0.0)?1.0:-1.0;  /*2.0*y/len;*/
      }
  }
}

static void each_distance (node n,float* vect)
 {
   float x=n->x-vect[2];
   float y=n->y-vect[3];
   float norm;
   if ((x > 0.5) || (x < -0.5) || (y > 0.5) || (y < -0.5)){
     norm=sqrt(x*x+y*y);
     x/=norm;
     y/=norm;
     norm=sqrt(40.0/norm)-0.3;
     norm=MAX(norm,0);
     vect[0]+=x*2.0*norm;
     vect[1]+=y*2.0*norm;
  }
}

static void distance (node n)
{
  float vector[4];
  float norm;
  vector[0]=vector[1]=0.0;
  vector[2]=n->x;
  vector[3]=n->y;
  iterate_table_entries(n->s->nodes,each_distance,vector);
  /*  norm=sqrt(vector[0]*vector[0]+vector[1]*vector[1]);*/
  n->fx-=vector[0];
  n->fy-=vector[1];
}

int position_node(node n)
{
  centering(n);
  edge_spring(n);
  distance(n);			
}

