#include <protocol/protocol.h>

#define flip(x) ((x)>>24|((x)&0xff0000)>>16|((x)&0xff00)<<8|(x)<<24)

static void down(layer l,pbuffer b,int f)
{
  pbuffer k;
  int i,len;
  if (b){
    len=buffer_length(b);
    for (i=0;i<len;i+=48){
      k=allocate_downwards_buffer(l,48);
      buffer_copy(k,0,b,i,48);
      write_down(l,k,f);
      dereference_buffer(k);
    }
  }
}


static void up(layer l, pbuffer b, int f)
{
  pbuffer temp;
  int i,length;
  if (b){
    length=buffer_length(b);
    for (i=0;i<length;i+=48){
      write_up(l,temp=allocate_fragment(b,i+4,flip(buffer_read_long(b,i))),f);
      dereference_buffer(temp);
    }
  } else {
    write_up(l,0,f);
  }
}

static pbuffer this(layer l,int size)
{
  int i,z;
  int total=((size+PAD_LENGTH(size,44))/44)*48;
  pbuffer k=allocate_buffer(total),temp;
  pbuffer result=0;
  for (i=0;i<total;i+=48){
    z=(size>44)?44:size;
    buffer_write_long(k,i,flip(z));
    result=append_buffer(result,temp=allocate_fragment(k,i+4,z));
    dereference_buffer(temp);
    size-=44;
  }
  result->down=k;
  return(result);
}
#ifdef SUN
#ifdef KERNEL
#include </usr/include/sys/ioccom.h>
#include </usr/include/sys/termio.h>
#endif
#endif


static ptai_break(void *dev,int cmd,void *data, int flag, layer l)
{
  pbuffer b=allocate_downwards_buffer(l,48);
  buffer_write_long(b,0,0);
  printf("ptai break\n");
  write_down(l,b,0);
}

layer create_cm_framer()
{
  layer l;
  l=create_layer(0,down,up,this);
#ifdef SUN
#ifdef KERNEL  
  register_ioctl_handler(TCSBRK,ptai_break,l);
#endif
#endif
  return(l);
}
