#include <protocol/protocol.h>
double drand48();

typedef struct estate{
     unsigned int drop,berr;
} *estate;


static pbuffer errorify (estate e, pbuffer b)
{
  int i;
  pbuffer result=0;
  int length=buffer_length(b);
  char f;
  
  if (random_long()%e->drop){
    if (e->berr){
      result=allocate_buffer(length);
      for (i=0;i<length;i++){
	buffer_read(b,i,&f,1);
	if (!(random_long()%(e->berr>>3))) f^=(1<<(random_long()&255));
	buffer_write(result,i,&f,1);
      }
    } else {
      reference_buffer(b);
      result=b;
    }
  }
  return(result);
}


void error_receive_up(layer l, pbuffer b, int flags)
{
  pbuffer b2;
  if (b2=errorify(l->state,b)){
    write_down(l,b2,flags);
    dereference_buffer(b2);
  }
}

void error_receive_down(layer l, pbuffer b, int flags)
{
  pbuffer b2;
  if (b) {
    if (b2=errorify(l->state,b)) {
      write_up(l,b2,flags);
      dereference_buffer(b2);
    }
  } else {
    write_up(l,b,flags);
  }
}

layer create_errors(unsigned int drop,unsigned int berr)
{
  estate new=(estate)allocate_memory(sizeof(struct estate));
  new->drop=drop;
  new->berr=berr;
  return(create_layer(new,error_receive_up,error_receive_down,0));
}






