#include <protocol/protocol.h>

typedef struct transaction {
  pbuffer b;
  int flags;
  struct transaction *next;
} *transaction;

typedef struct pacer {
  layer l;
  transaction q;
  transaction *qt;
  int pending;
  int interval;
  int frame_size;
} *pacer;

static int handler(pacer p)
{
  transaction n;
  if (!p->q) {
    p->pending=0;
    return(0);
  }
  write_down(p->l,p->q->b,p->q->flags);
  if (p->q->b) dereference_buffer(p->q->b);
  n=p->q->next;
  deallocate_memory(p->q);
  if (!(p->q=n)) p->qt=&p->q;
  return(1);
}

static void down(layer l,pbuffer b,int f)
{
  pacer p=(pacer)l->state;
  transaction t=(transaction)allocate_memory(sizeof(struct transaction));
  t->b=b;
  if (b) reference_buffer(b);
  t->flags=f;
  t->next=0;
  *p->qt=t;
  p->qt=&t->next;
  if (!p->pending){
    p->pending=1;
    register_timer(p->interval,handler,p);
  }
}

layer create_pacer(unsigned int interval)
{
  pacer p=(pacer)allocate_memory(sizeof(struct pacer));
  p->interval=interval;
  p->pending=0;
  p->q=0;
  p->qt=&p->q;
  return(p->l=create_layer(p,down,0,0));
}
