#include <protocol/protocol.h>
#include <elib/machine.h>

static char hex_digits[]={'0','1','2','3','4','5','6','7','8','9','a',
			    'b','c','d','e','f'};


void print_buffer(char *p, pbuffer b)
{
  int count,len,i;
  unsigned int trash;
  unsigned char z,y;
  char s[3];
  PUT_BYTE(s,2,0);
  if (b && p) {
    len=buffer_length(b);
    for (count=0;count<len;count){
      if (!(count%24)) printf ("\n%s",p);
      buffer_read(b,count++,&z,1);
      PUT_BYTE(s,0,hex_digits[(z>>4)&15]);
      PUT_BYTE(s,1,hex_digits[z&15]);
      printf ("%s",s);
      if (!(count%4)) printf (" ");
    }
    printf ("\n");
  }
}

static void print_down(layer l, pbuffer b, unsigned int flags)
{
  char **tags=(char **)l->state;
  print_buffer(tags[1],b);
  write_down(l,b,flags);
}

static void print_up(layer l, pbuffer b, unsigned int flags)
{
  char **tags=(char **)l->state;
  print_buffer(tags[0],b);
  write_up(l,b,flags);
}

layer create_print(char *up,char *down)
{
  char **tags=(char **)allocate_memory(2*sizeof(char *));
  int i;
  tags[0]=tags[1]=0;

  if (up){
    tags[0]=(char *)allocate_memory(15);
    for (i=0;i<14;i++) PUT_BYTE(tags[0],i,' ');
    bcopy (up,tags[0],MIN(string_length(up),9));
    PUT_BYTE(tags[0],14,0);
  }
  if (down){
    tags[1]=(char *)allocate_memory(15);
    for (i=0;i<14;i++) PUT_BYTE(tags[1],i,' ');
    bcopy (down,tags[1],MIN(string_length(down),9));
    PUT_BYTE(tags[1],14,0);
  }
  return(create_layer(tags,print_down,print_up,0));
}
