#include <protocol/protocol.h>
#include <elib/memory.h>
#include <elib/command.h>
#include <skip/skip.h>
#include <fcntl.h>

void assemble_stack();
void write_up_internal();
void write_down_internal();
extern layer create_print();
extern layer create_sscop();
extern layer create_frob();
extern layer create_blast();
extern layer create_filedesc();
extern layer create_aal5();
extern layer create_aal4();
extern layer create_udp();
extern layer create_llc();
extern layer create_tcp();
extern layer create_nit();
extern layer create_enet();
extern layer create_cm_framer();
extern layer add_llc_snap();
extern layer create_framer();
extern layer create_enet_handler();
extern layer create_ip();
extern layer create_process();


static void i363_down(layer l,pbuffer b,int f)
{
  pbuffer message;
  int i;
  unsigned char e;

  if (f&PROTOCOL_CONNECTED){
    message=allocate_downwards_buffer(l,40);
    for (i=0;i<40;i++) buffer_write_byte(message,i,0);
    write_down(l,message,0);
    dereference_buffer(message);
    
    message=allocate_downwards_buffer(l,40);
    for (i=0;i<40;i++) buffer_write_byte(message,i,255);
    write_down(l,message,0);
    dereference_buffer(message);
    
    message=allocate_downwards_buffer(l,40);
    for (i=0;i<40;i++) buffer_write_byte(message,i,i+1);
    write_down(l,message,0);
    dereference_buffer(message);
  }
}


layer aal5_i363_test()
{
  return(create_layer(0,0,i363_down,0));
}

static int my_open(char *s)
{
  return(open(s,O_RDWR|O_CREAT));
}

static pbuffer allocate_down(layer l, int s)
{
  int *z=(int *)l->state,i;
  int size=(s+PAD_LENGTH(s,z[1]))/z[1];
  pbuffer b=allocate_downwards_buffer(l,size*(z[0]+z[1]));
  pbuffer d=0,temp;
  for (i=0;i<size;i++){
    d=append_buffer(d,temp=allocate_fragment(b,i*(z[0]+z[1])+z[0],z[1]));
    dereference_buffer(temp);
  }
  d->down=b;
  return(d);
}

layer skew_up(layer l, pbuffer b, int f)
{
  int *z=(int *)l->state;
  pbuffer temp;
  int number,i;
  if (b){
    number=buffer_length(b)/(z[0]+z[1]);
    for (i=0;i<number;i++){
      write_up(l,temp=allocate_fragment(b,i*(z[0]+z[1])+z[0],z[1]),
	       (i==(number-1))?PROTOCOL_END_OF_MESSAGE:0);
      dereference_buffer(temp);
    }
  } else {
    write_up(l,0,f);
  }
}

layer create_skew(n,m)
{
  int *z=(int *)allocate_memory(2*sizeof(int));
  z[0]=n;
  z[1]=m;
  return(create_layer(z,0,skew_up,allocate_down));
}


layer create_reflector()
{
  return(create_layer(0,write_up_internal,write_up_internal,0));
}


static void puts(char *a)
{
  write(1,a,strlen(a));
}

main()
{
  command_space sp;
  initialize_timer();
  initialize_skip();
  
  assemble_stack(2,create_skip_layer(skip_global_environment),
		 create_filedesc(0,1,512,0));
  
  skip_type ('L',"layer",command_parse_hex,command_print_hex,
		deallocate_memory);
  skip_type ('x',"hex",command_parse_hex,command_print_hex,
		deallocate_memory);
  skip_function(assemble_stack,"assemble_stack","","iL*",0);
  skip_function(create_frob,"create_frob","L","iiii",0);
  skip_function(create_blast,"create_blast","L","ii",0);
  skip_function(create_filedesc,"create_filedesc","L","iiii",0);
  skip_function(create_reflector,"create_reflector","L","",0);
  skip_function(create_skew,"create_skew","L","ii",0);
  skip_function(create_print,"create_print","L","ss",0);
  skip_function(create_aal5,"create_aal5","L","i",0);
  skip_function(create_aal4,"create_aal4","L","i",0);
  skip_function(create_udp,"create_udp","L","ssss",0);
  skip_function(add_llc_snap,"add_llc_snap","L","Lxx",0);
  skip_function(create_llc,"create_llc","L","",0);
  skip_function(create_cm_framer,"create_cm_framer","L","",0);
  skip_function(aal5_i363_test,"aal5_i363_test","L","",0);
  skip_function(create_nit,"create_nit","L","siii",0);
  skip_function(create_framer,"create_framer","L","i",0);
  skip_function(create_enet,"create_enet","L","",0);
  skip_function(create_enet_handler,"create_enet_handler","L","Lx",0);
  skip_function(my_open,"open","i","s",0);
  skip_function(puts,"puts","","s",0);
  skip_function(create_process,"create_process","L","sis*",0);
  timer_loop(1,0);
}

