#include <anemone.h>
#include <math.h>

static struct shape oval_struct={
  oval_shape,0,
  {{0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0}},
  {{0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0}},
  {{0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0},
   {0.0,0.0}},
};

static shape hexagon;
static shape oval=&oval_struct;
static shape triangle;
static shape square;
static shape ring;
static shape line;

static shape generate_polygon(unsigned int code,unsigned int sides,
		       float rotation)
{
  shape s=(shape)allocate_memory(sizeof(struct shape));
  unsigned int i;
  float x0,y0,x1,y1;
  float theta,interval=2.0*3.1415926535/sides,d;
  s->degree=sides;
  s->kind=code;
  for (i=0,theta=interval/2.0;i<s->degree;i++,theta+=interval){
    s->points[i].x=0.75*cos(theta);
    s->points[i].y=0.75*sin(theta);
    if (i) {
      x0=MIN(x0,s->points[i].x);
      y0=MIN(y0,s->points[i].y);
      x1=MAX(x1,s->points[i].x);
      y1=MAX(y1,s->points[i].y);
    } else {
      x0=x1=s->points[i].x;
      y0=y1=s->points[i].y;
    }
    s->edge_locations[i].x=(cos(theta)+cos(theta+interval))/2;
    s->edge_locations[i].y=(sin(theta)+sin(theta+interval))/2;
    s->edge_normals[i].x=cos(theta+interval/2);
    s->edge_normals[i].y=sin(theta+interval/2);
  }
  x0=MAX((x1-x0),(y1-y0))*0.5;
  for (i=0;i<s->degree;i++){
    s->points[i].x*=x0;
    s->points[i].y*=x0;
  }
  return(s);
}

shape resolve_shape_name (char *s)
{

    if (strcmp(s,"oval")==0) return(oval);
    if (strcmp(s,"square")==0) return(square);
    if (strcmp(s,"triangle")==0) return(triangle);
    if (strcmp(s,"hexagon")==0) return(hexagon);
    if (strcmp(s,"line")==0) return(line);
    if (strcmp(s,"ring")==0) return(ring);
    return(0);
}

char *shape_name (shape sh)
{
  if (sh==0) return("none");
  if (sh==oval) return("oval");
  if (sh==square) return("square");
  if (sh==triangle) return("triangle");
  if (sh==hexagon) return("hexagon");
  if (sh==line) return("line");
  if (sh==ring) return("ring");
}


void initialize_shapes()
{
  hexagon=generate_polygon(hex_shape,6,0.0);
  square=generate_polygon(square_shape,4,0.0);
  line=generate_polygon(line_shape,4,0.0);
  triangle=generate_polygon(triangle_shape,3,0.0);
  ring=(shape)allocate_memory(sizeof(struct shape));
  ring->kind=ring_shape;
}
