#include <elib/list.h>
#include <elib/command.h>
#include <elib/table.h>

typedef struct environment {
  table variables;
  command_space space;
  struct environment *parent;
  int reference_count;
} *environment;

typedef struct parser_frame {
  struct parser *p;
  struct parser_frame *parent;
  char *(*result_function)();
  void *result_arg;
  int flags;
  char *terminal; 
  int backslash;
  int fill_pointer;
  int free_length;
  int argc;
  char *argv[30];
} *parser_frame;

typedef struct parser {
  parser_frame top;
  environment e;
  char *(*result_function)();
  void *result_arg;
} *parser;

typedef struct lambda {
  list arguments;
  list variables;
  char *body;
  environment parent;
} *lambda;

typedef struct coontinuation {
  int foo;
} *continuation;

char* skip_eval();
environment create_environment();
extern environment skip_global_environment;
parser create_skip_parser();
