#include <skip/skip.h>
#include <protocol/protocol.h>
#include <fcntl.h>

typedef struct skip_layer {
  environment e;
  parser p;
  layer l;
} *skip_layer;

static void result(skip_layer s,int argc,char **argv)
{
  pbuffer result;
  int rlen=0;
  
  if (argc)
    if (argv[0])
      rlen=string_length(argv[0]);
  if (s->l->up) result=allocate_buffer(rlen+1);
  if (s->l->down) result=allocate_downwards_buffer(s->l,rlen+1);
  if (argc)
    if (argv[0])
      buffer_write(result,0,argv[0],rlen);
  /*  command_free_result(cresult);*/
  buffer_write_byte(result,rlen,'\n');
  if (s->l->up) write_up(s->l,result,0);
  if (s->l->down) write_down(s->l,result,0);
  dereference_buffer(result);
}

static void handle_message(layer l, pbuffer b, int f)
{
  skip_layer s=(skip_layer)(l->state);
  pbuffer i;
  int j;
  
  for (i=b;i;i=i->next)
    for (j=0;j<i->length;j++)
      if (i->contents[j]!=13) skip_parse(s->p,i->contents[j]);
}


layer create_skip_layer(environment e)
{
  skip_layer s=(skip_layer)allocate_memory(sizeof(struct skip_layer));
  s->e=e;
  s->p=create_skip_parser(e,result,s);
  return(s->l=create_layer(s,handle_message,handle_message,0));
}


void skip_load_file(environment e,char *s)
{
  int fd;
  layer l;
  pbuffer b;
  char chunk[512];
  int i,result;
  parser p;
  
  if ((fd=open(s,O_RDONLY)) >= 0){
    p=create_skip_parser(e,0,0);
    while ((result=read(fd,chunk,512)) > 0)
      for (i=0;i<result;i++) skip_parse(p,chunk[i]);
  }
}


static void eval_result(char **place,int argc,char **argv)
{
  if (argc) *place=argv[0];
}

char *skip_eval_string(environment e,char *s)
{
  char *k=0;
  parser p=create_skip_parser(e,eval_result,&k);
  for (;*s;s++) skip_parse(p,*s);
  skip_parse(p,'\n');
  return(k);
}

