#include <sys/types.h>
#include <sys/dir.h>
#include <elib/string.h>
#include <sys/fcntl.h> 
#include <stdarg.h>
#include <sys/stat.h>
#include <unistd.h>

#define CHUNK 512

void each_file(int fd,void (*function)(), void *arg)
{
  int len,p;
  long base=0;
  unsigned short buf[CHUNK], *k;
  char *name;

  lseek(fd,0,SEEK_SET);
  while((len=getdirentries(fd, (char *)buf, sizeof(unsigned short)*CHUNK,
			   &base))>0)
    for(p=0,k=buf;p<len;p+=k[2],k+=k[2]/2)
      (*function)(k+4,arg);
}

int fileopen(char *format,...)
{
  int result=0,k,len;
  char *t;

  va_list a;
  va_start(a,format);
  t=format_string_internal(format,&len,a);
  if ((k=open(t,O_RDONLY))>0) result=k;
  deallocate_memory(t);
  return(result);
}

int file_is_directory(int fd)
{
  struct stat buf;
  fstat(fd,&buf);
  return (buf.st_mode & S_IFDIR);
}

int more_recent (int a,int b)
{
  struct stat bufa,bufb;
  fstat(a,&bufa);
  fstat(b,&bufb);
  return (bufa.st_mtime > bufb.st_mtime);
}
