#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <elib/machine.h>

struct sockaddr_in *make_numeric_sockaddr_in(unsigned int host,
					     unsigned short port)
{
  struct sockaddr_in *new=(struct sockaddr_in *)
    allocate_memory(sizeof( struct sockaddr_in ));
  bzero (new,sizeof(struct sockaddr_in));  
  host=vhtonl(host);
  bcopy (&host, &new->sin_addr, 4);
  new->sin_port = htons(port); 
  new->sin_family = AF_INET;
  return(new);
}

struct sockaddr_in *make_sockaddr_in(char *hostname,char *service)
{
  struct hostent *he;
  struct servent *se;
  unsigned long haddr;
  unsigned short port;
  int a,b,c,d;
  struct sockaddr_in *new=(struct sockaddr_in *)
    allocate_memory(sizeof( struct sockaddr_in ));

  bzero (new,sizeof(struct sockaddr_in));  
  if (!(he=gethostbyname(hostname))){
    if (sscanf(hostname,"%d.%d.%d.%d",&a,&b,&c,&d)==4){
      haddr=vhtonl(a<<24|b<<16|c<<8|d);
    } else {
      printf("no such host %s",hostname);
      deallocate_memory(new);
      return(0);
    }
  } else bcopy(he->h_addr,&haddr,4);

  getservent(); 
  if (!(se=GETSERVICE(service))){
    port=atol(service);
    if (!port) return(0);
  } else {
    port= se->s_port; 
  }
  endservent();  
  new->sin_family = AF_INET;
  /*  haddr=htonl(haddr);*/
  bcopy (&haddr, &new->sin_addr, 4);
  new->sin_port = htons(port); 
  return(new);
}

