#include <anemone.h>
#include <x.h>

void draw_x_button(panel p,button b,
			unsigned int x,unsigned int y,
			unsigned int width,unsigned int height)
{
  int len;
  int left_margin=10;
  XCharStruct overall;
  int direction,ascent,descent;
  GC lrgc,ulgc;

  ulgc=b->pressed?p->s->dark_underscore:p->s->overscore;
  lrgc=b->pressed?p->s->overscore:p->s->underscore;
  len=string_length(b->name);
  XTextExtents (p->s->f,b->name,len,&direction,&ascent,&descent,&overall);
  XDrawLine(p->s->d,p->p,ulgc,1,y+2,width-1,y+2);
  XDrawLine(p->s->d,p->p,ulgc,1,y+2,1,y+height);
  XDrawLine(p->s->d,p->p,lrgc,width-1,y+2,width-1,y+height);
  XDrawLine(p->s->d,p->p,lrgc,1,y+height,width-1,y+height);
  if ((overall.lbearing+overall.rbearing <= width) &&
      (overall.ascent+overall.descent <= height))
    XDrawString(p->s->d,p->p,p->s->panel_gc,left_margin,
		y+height-ascent/2,b->name,len);
}


void add_button(panel p,char *name,XImage *cursor,int (*frob)(),
		void *frob_arg,
		int type)
{
  button b=(button)allocate_memory(sizeof(struct button));
  b->name=duplicate_string(name);
  b->pressed=0;
  b->p=p;
  b->c=cursor;
  b->frob=frob;
  b->frob_arg=frob_arg;
  b->type=type;
  b->was_pressed=0;
  append_list(&p->buttons,insert(b,0));
  draw_buttons(p);
}

void disarm_button(button b)
{
  /*  b->pressed=0;			/*  */
}

void press_button(button b)
{
  if (b->type){
    b->was_pressed=b->pressed;
  } else {
    b->was_pressed=1;
  }
  b->pressed=1;
  draw_buttons(b->p);
  (*b->p->s->sp->snap)(b->p->s->sp);
}

void release_button(button b)
{
  b->pressed=b->was_pressed^1;
  draw_buttons(b->p);
  if (b->frob) (*b->frob)(b->frob_arg,b->pressed);
/*  if (b->c) {
    XDefineCursor(b->p->s->d,b->p->s->w);
  }
*/
  (*b->p->s->sp->snap)(b->p->s->sp);
}
