#include <anemone.h>
#include <x.h>

/*#define ARROW 1*/
void draw_x_edge(space sp,edge e)
{
  xspace s=(xspace)sp->hardware_local;
  int size=e->width*s->xscale;
  float x,y,d,x0,y0;
  float xf,yf,xt,yt;

  /* recursively call redraw?...perhaps better
     to mark instruments as dirty*/
  
  if (s->current_edge_color !=e->color){
    XSetForeground(s->d,s->edge_gc,x_display_color_from_color(s,e->color));
    s->current_edge_color=e->color;
  }
  if (s->current_width !=size){
    XSetLineAttributes(s->d,s->edge_gc,size,LineSolid,CapButt,JoinMiter);
    XSetLineAttributes(s->d,s->arrow_gc,size/4,LineSolid,CapRound,JoinMiter);
    s->current_width =size;
  }

  edge_position(e->from,e->to,&xf,&yf);
  edge_position(e->to,e->from,&xt,&yt);
  XDrawLine(s->d,s->p,s->edge_gc,
	    xform(s,xf,yf),
	    yform(s,xf,yf),
	    xform(s,xt,xt),
	    yform(s,xt,yt));

  if (e->from_tag){
    if ((xf-e->from->x)>0)	
      draw_text(s,e->from_tag,xform(s,xf,yf),yform(s,xf,yf),
		100,100,s->edge_label_gc);
    else
      draw_text(s,e->from_tag,xform(s,xf,yf)-100,yform(s,xf,yf),
		100,100,s->edge_label_gc);
  }
  
  if (e->to_tag){
    if ((xt-e->to->x)>0)
      draw_text(s,e->to_tag,xform(s,xt,yt),yform(s,xt,yt),
		100,100,s->edge_label_gc);
    else
      draw_text(s,e->to_tag,xform(s,xt,yt)-100,yform(s,xt,yt),
		100,100,s->edge_label_gc);
  }

/* this should be an edge property...and be done correctly*/
#ifdef ARROW
  if (s->current_width !=size){
    XSetLineAttributes(s->d,s->edge_gc,size,LineSolid,CapButt,JoinMiter);
    s->current_width =size;
  }
  x=xform(s,e->to->x,e->to->y)-(x0=xform(s,e->from->x,e->from->y));
  y=yform(s,e->to->x,e->to->y)-(y0=yform(s,e->from->x,e->from->y));
  d=sqrt(x*x+y*y);
  x/=d;  
  y/=d;  
  XDrawLine(s->d,s->p,s->arrow_gc,
	    (int)(x0+x*(d/2.0+size)),
	    (int)(y0+y*(d/2.0+size)),
	    (int)(x0+x*(d-size)/2.0+(y*size/2.0)),
	    (int)(y0+y*(d-size)/2.0-(x*size/2.0)));
  XDrawLine(s->d,s->p,s->arrow_gc,
	    (int)(x0+x*(d/2.0+size)),
	    (int)(y0+y*(d/2.0+size)),
	    (int)(x0+x*(d-size)/2.0-(y*size/2.0)),
	    (int)(y0+y*(d-size)/2.0+(x*size/2.0)));

#endif
}
